
#include <iostream.h>
#include <math.h>
#include <string.h>
#include <stdio.h>

struct RGB { 
  double r;
  double g;
  double b;
};

#define M_SQRT2 1.4142135623730950488016887242097

class haarDecomp {

  protected :
     
  struct RGB * image;
  struct RGB * wavelet;

  int * mark;

  int resX,resY;
  int currentHeight,currentWidth;
  int nbDecomposition;

  bool smooth;
  bool loaded;

  public :

  haarDecomp();
  ~haarDecomp();
  
  bool loadImage(char name[50],int * width,int * height);
  void setSmooth(bool s);

  bool decompositionStep(struct RGB * buf,int * mark,int width,int offset);
  bool decompose();

  bool reconstructionStep(struct RGB * buf,int * mark,int width,int offset);
  bool reconstruct();

  void waveletDecomposition();
  void waveletReconstruction();

  void compress();

  void reset();
  void writePPM(int resX,int resY);

  void drawImage();

};
