/**************************************************************************************************/
/**************************************************************************************************/

#include "glut.h"
#include "haarDecomp.h"

/**************************************************************************************************/
/**************************************************************************************************/

int resX,resY;
haarDecomp * hd;

/**************************************************************************************************/
/**************************************************************************************************/

static void draw( void )
{
  
  glClear( GL_COLOR_BUFFER_BIT );

  hd->drawImage();

  glutSwapBuffers();

}

/**************************************************************************************************/
/**************************************************************************************************/

static void mouse(int button, int state, int x, int y) {}

/**************************************************************************************************/
/**************************************************************************************************/

static void motion( int x, int y ) {}

/**************************************************************************************************/
/**************************************************************************************************/

static void key( unsigned char key, int x, int y )
{
   switch (key) {
   case 27:               /* sortie si ESC */
     exit(0);
   case '+' : 
     hd->decompose();
     break;
   case '-' : 
     hd->reconstruct();
     break;
   case 'd' :
     hd->waveletDecomposition();
     break;
   case 'r' :
     hd->waveletReconstruction();
     break;
   case 'c' :
     hd->compress();
     break;
   case 'z' :
     hd->reset();
     break;
   case 'w' :
     hd->writePPM(resX,resY);
     break;
   default : 
     break;
   }

   glutPostRedisplay();

}


/**************************************************************************************************/
/**************************************************************************************************/

static void reshape( int width, int height )
{

  resX = width;
  resY = height;

  glViewport(0, 0, width, height);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glutPostRedisplay();

}

/**************************************************************************************************/
/**************************************************************************************************/

int main( int argc, char *argv[]) {

  bool ok;
	cout << "##################################" << endl;
	cout << "#  Wavelet Decomposition         #" << endl;
	cout << "##################################" << endl << endl;

	cout << " KEY : " << endl;
	cout << "+ : Do on decomposition" << endl;
	cout << "- : Undo last decomposition" << endl;
	cout << "d : Do total decomposition" <<endl;
	cout << "r : Do total reconstruction" <<endl;
	cout << "c : Compress picture (only if total decomposition)" <<endl;   
	cout << "z : Reset" <<endl;   
	cout << "w : Write current picture to image.ppm" <<endl;   

	hd = new haarDecomp();

  ok = hd->loadImage(argv[1],&resX,&resY);

  if (ok) {
    glutInitWindowPosition(100, 100);
    glutInitWindowSize(resX,resY);
    glutInitDisplayMode( GLUT_RGB|GLUT_DOUBLE );
    
    if (glutCreateWindow("Decomposition en ondelettes") <= 0) {
      exit(0);
    }
  
    glutReshapeFunc( reshape );
    glutKeyboardFunc( key );
    glutDisplayFunc( draw );
    glutMouseFunc( mouse );
    glutMotionFunc( motion );
    glutMainLoop();
  }

  return 0;

}
  
/**************************************************************************************************/
/**************************************************************************************************/



